/* AppMovieController */

#import <Cocoa/Cocoa.h>
#import <QTKit/QTKit.h>
#import <Quicktime/Quicktime.h>

#import	"QTResponder.h"
#import "PCTCformatter.h"
#import "QTInfoDisplayView.h"

#define LOG_SELECTOR NSLog(@"%s", __PRETTY_FUNCTION__)

enum SELECTION_CHANGE_OPTIONS {
	kADVANCE,
	kRETARD
};

@interface AppMovieController : NSObject
{
	IBOutlet QTMovieView *myMovieView;
	IBOutlet NSTextField *positionTextField;
	IBOutlet NSTextField *movieStartField;
	IBOutlet NSWindow *mainWindow;
	IBOutlet QTInfoDisplayView *_timeWindowView;
	
	IBOutlet NSButton *showTimeStartButton;
	IBOutlet NSButton *closeButton;
	IBOutlet NSPopUpButton *frameRateSelectPopUpButton;
	IBOutlet NSMatrix *frameDisplayType;
	
	NSMutableArray *theReelVersionMovies;
	
	NSNumber *pictureStartPosition;
	NSMutableDictionary *theReelVersion;
	BOOL hasMovie;
	NSNumber *currentPosition;
	NSNumber *currentLocatePosition;
	NSSize pictureSize;
	
	NSTimer *_currentMovieTimeTimer;
	PCTCformatter *theFormatter;
	
	BOOL blankMovie;
	BOOL  _forceMovieUpdate;

	QTResponder *_qtResponder;
	
	BOOL _movieDebug;
	
	BOOL _isInLoopMode;
	
	NSNumber *shouldDisplayTimeInfo;
}


- (void)setMovieRate:(NSNotification*)notification;
- (void)stopMovie:(NSNotification*)notification;
- (void)stepNextFrame:(NSNotification*)notification;
- (void)stepPreviousFrame:(NSNotification*)notification;
- (void)responderAction:(NSNotification*)notification;

-(void)playMovie;
-(void)playMovieForwardNoStop;
-(void)playMovieBackwardsNoStop;
-(void)startPolling;
-(void)stopPolling;

-(void)locate;
-(void)locateWithOptions;
-(void)creatNewLocate;
-(void)appLoopPlay:(id)cue;
-(void)adjustSelection:(int)options;

-(QTTimeRange)rangeFromGoToTime:(NSNumber*)thePositionToStartFrom withOutTime:(NSNumber*)theOutime;
-(QTTimeRange)rangeFromGoToTime:(NSNumber*)thePositionToStartFrom withDuration:(NSNumber*)theDuration;

-(void)setTheReelVersion:(NSMutableDictionary*)newVersion;
-(NSMutableDictionary*)theReelVersion;
-(void)setPictureStartPosition:(NSNumber*)newVal;
-(NSNumber*)pictureStartPosition;
-(void)setHasMovie:(BOOL)newVal;
-(BOOL)hasMovie;

-(QTMovie*)movieForPath:(NSString*)thePath;
-(NSSize)sizeForPath:(NSString*)thePath;
-(void)silentlyUpdateMovieWithPath:(NSString*)theNewPath;
-(void)silentlyUpdateMovieWithNewAudioAlreadySpecified:(id)selection;

-(void)setCurrentPosition:(NSNumber*)newVal;
-(NSNumber*)currentPosition;
-(void)setCurrentLocatePosition:(NSNumber*)newVal;
-(NSNumber*)currentLocatePosition;
-(void)updateMovieSize;

-(IBAction)goToTime:(NSNumber*)thePositionToStartFrom;
-(IBAction)goToTime:(NSNumber*)thePositionToStartFrom withOutTime:(NSNumber*)theOutime;
-(IBAction)goToTime:(NSNumber*)thePositionToStartFrom withDuration:(NSNumber*)theDuration;
/*
-(IBAction)showTimeStartSheet:(id)sender;
-(IBAction)closeTimeStartSheet:(id)sender;
*/

-(unsigned long long)inTimeFromCurrentMovie;
-(unsigned long long)outTimeFromCurrentMovie;
-(unsigned long long)grabCurrentPosition;

- (PCTCformatter *)theFormatter;
- (void)setTheFormatter:(PCTCformatter *)newTheFormatter;

-(QTMovieView*)myMovieView;
-(void)setForceMovieUpdate:(BOOL)update;


-(void)setShouldDisplayTimeInfo:(NSNumber*)newValue;
-(NSNumber*)shouldDisplayTimeInfo;

@end
